/*
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "Producer.h"
#include <ocstring.h>
#include <set.h>
#include "ByteArray.h"
#include "IdentifierTranslation.h"
#include "assert.h"

	IMPORT id identifierTranslator, globalSymbols;

@implementation IdentifierTranslation:ByteArray 
	{ id type, targetIdentifier; }
+ sourceName:sourceIdentifier targetType:aType targetName:anIdentifier {
	id result;
	self = [super str:[sourceIdentifier str]]; [sourceIdentifier free];
	targetIdentifier = anIdentifier;
	if (aType == 0 || aType == types.UNKNOWN) type = types.ID;
	else type = aType;
	[targetIdentifier type:type rule:"explicit rule"];
#ifndef COXLIB
	if ([identifierTranslator addNTest:self]) result = self;
	else result = [identifierTranslator find:self];
#else
	result = [identifierTranslator add:self];
#endif
	if (result && result != self && [result type] != type) {
		dbg("result=%x result type=%x\n", result, [result type]);
		wer("incompatible translations for identifier %s. Using %s, ignoring %s",
			[self str], [type str], [[result type] str]);
	}
	[globalSymbols add:self];
	return self;
}
- type
	{ return type; }
- type:aType rule:(STR)aString { 
	info("IdentifierTranslation %s ignored type change from %s to %s",
		[self str], [type str], [aType str]);
	return self; 
}
- gen 
	{ gs([targetIdentifier str]); return self; }
- genDeclaration { 
	[type gen]; gc(' '); gs([targetIdentifier str]); gc(';');
	return self;
}
- targetIdentifier
	{ return targetIdentifier; }
- free
	{ return nil; }
- asTypedByteArray 
	{ return [ByteArray sprintf:"(%s)%s", [type str], [self str]]; }
@end

