/*
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "Producer.h"
#include <idarray.h>
#include "MsgArgPattern.h"
#include "Msg.h"
#include "Node.h"

@implementation MsgArgPattern : IdArray 
	{ id translation; }
+ template:aTemplate translation:aTranslation { id s; unsigned i = 0;
	self = [self new:[aTemplate size]+1];
	[self at:i++ put:[aTemplate receiverType]];
	for (s = [aTemplate selector]; s; s = [s successor]) {
		id t = [s type];
		if (t == 0 || t == types.UNKNOWN) t = types.ANY;
		[self at:i++ put:t];
	}
	return [self translation:aTranslation];
}
- type
	{ return [translation type]; }
- translation:aTranslation
	{ translation = aTranslation; return self; }
- translation
	{ return translation; }
@end

