/*
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "Producer.h"
#include <ordcltn.h>
#include <set.h>
#include <ocstring.h>
#include "Scope.h"

	EXPORT id symbolScope  = nil,
		undefinedSymbols = nil,
		globalSymbols = nil,
		identifierTranslator = nil;
	
@implementation Scope:OrderedCollection 
+ initialize { 
	if (!symbolScope) {
		symbolScope = [self new]; 
		undefinedSymbols = [Set new];
		globalSymbols = [Set new];
		[symbolScope add:globalSymbols];
		[symbolScope add:undefinedSymbols];
		identifierTranslator = [Set new];
	}
	return self;
}
@end

id findSymbol(aVariable) id aVariable; {
	int i, n = [symbolScope size];
	for (i = n-1; i >= 0; i--) { id hit;
		if (hit = [[symbolScope at:i] find:aVariable]) 
			return hit;
	}
	info("undefined %s %s\n", NAMEOF(aVariable), [aVariable str]);
	[undefinedSymbols add:aVariable]; return aVariable;
}

