/*
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "Producer.h"
#include "Node.h"
#include "Stmt.h"

@implementation Stmt:Node
	{ id expr, type; }

+ expr:anExpr { self = [super new]; expr = anExpr; return self; }
- expr { return expr; }
- free { [expr free]; return [super free]; }
- gen {
	[expr gen]; if (type != types.STMT) gc(';'); 
	[successor gen]; return self; 
}
- genExpr { [expr gen];
	if (successor) { if (type != types.STMT) gc(';'); [successor gen]; }
	return self; 
}
- type { 
	if (type) return type;
	type = [expr type]; 
	[successor type];
	return type;
}
@end

