/*
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published 
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "Producer.h"
#include <ocstring.h>
#include "ByteArray.h"
#include "Symbol.h"
#include "Constant.h"
#include "Type.h"
#include <set.h>

	TYPE types = { 0 };
	LOCAL id knownTypes;

@implementation Type : Constant 
+ initialize { static BOOL beenHere;
	if (!beenHere) { beenHere = YES;
		self = Type; knownTypes = [Set new];

		/* C base types */
		types.ID = [self str:"id"];
		types.CHAR = [self str:"char"];
		types.SHORT = [self str:"short"];
		types.INT = [self str:"int"];
		types.LONG = [self str:"long"];
		types.FLOAT = [self str:"float"];
		types.DOUBLE = [self str:"double"];

		/* Common derived types */
		types.CSTRING = [self str:"STR"];
		types.POINT = [self str:"PT"];
		types.RECTANGLE = [self str:"RT"];

		/* Language types */
		types.BLOCK = [self str:"BLOCK"];
		types.STMT = [self str:"STMT"];
		types.SELECTOR = [self str:"SEL"];
		types.SHARED = [self str:"SHR"];

		/* Misc */
		types.UNKNOWN = [self str:"unknown"];
		types.ANY = [self str:"any"];
	}
	return self;
}
- type
	{ return self; }
@end

